
#include <MPU6050_tockn.h>
#include <Wire.h>
#include <SimpleKalmanFilter.h>
SimpleKalmanFilter lockalman(0.003,0.003,0.01);
int16_t gx, gy, gz;
int16_t gxkm,gykm,gzkm;
float gocx,gocy,gocz, gochuong,goctam, gocy1;
float t1 , t2, t3;
char caracter;

MPU6050 mpu6050(Wire);
void ResetBoard();
void setup() {
  Serial.begin(9600);
  Wire.begin();
  mpu6050.begin();
  mpu6050.calcGyroOffsets(true);
  mpu6050.setGyroOffsets(0, 0, 0);
}
void ResetBoard()
{
  asm volatile ( "jmp 0");  
}
void loop() {
  mpu6050.update();

  t1 = t2;
  t2= millis();
  t3 = (t2-t1)/1000.0;
  gx = mpu6050.getGyroX();
  gy = mpu6050.getGyroY();
  gz = mpu6050.getGyroZ();
  gxkm = gx/50;
  gxkm = lockalman.updateEstimate(gxkm);
   gocx = gocx + t3 * gxkm;
      goctam=1.4*gocx;

  gzkm=gz/50;
  gzkm = lockalman.updateEstimate(gzkm);
    gocz = gocz + t3 * gzkm;
      gochuong=1.15*gocz;
 
        Serial.print(goctam);
        Serial.print("|");
        Serial.print(gy);
        Serial.print("|");
        Serial.print(gochuong);
        Serial.print("\n"); // Fin de línea.  

  delay(100);
  if(Serial.available()) {
    caracter = Serial.read();

  if(caracter == '1')
  { 
     mpu6050.begin();
     mpu6050.calcGyroOffsets(true);
     mpu6050.setGyroOffsets(0, 0, 0);
}
     }
         }


